/* AppControler */

#import <Cocoa/Cocoa.h>

@class Network;

@interface AppControler : NSObject
{
    IBOutlet NSWindow *connectWindow;
    IBOutlet NSTableView *hostListTable;
    IBOutlet NSFormCell *titleField;
    IBOutlet NSFormCell *hostField;
    IBOutlet NSFormCell *userField;
    IBOutlet NSSecureTextField *passwordField;
    IBOutlet NSFormCell *pathField;
    IBOutlet NSFormCell *timeoutField;
    IBOutlet NSFormCell *logFileField;
    IBOutlet NSFormCell *localDirectoryField;
    IBOutlet NSPopUpButton *serverCodePopUp;
    IBOutlet NSButton *hideDotSwitch;
    IBOutlet NSButton *detailSwitch;
    IBOutlet NSButton *crlfSwitch;
    IBOutlet NSButton *sshTunnelSwitch;
    IBOutlet NSButton *passiveSwitch;
    IBOutlet NSButton *sshSwitch;

    IBOutlet NSWindow *hostWindow;
    IBOutlet NSTableView *fileListTable;
    IBOutlet NSTableColumn *fileListDir;

    IBOutlet NSWindow *messageWindow;

    IBOutlet NSWindow *inputWindow;
    IBOutlet NSTextField *inputField;

    IBOutlet NSWindow *permissionWindow;
    IBOutlet NSButton *userReadSwitch;
    IBOutlet NSButton *userWriteSwitch;
    IBOutlet NSButton *userExecuteSwitch;
    IBOutlet NSButton *groupReadSwitch;
    IBOutlet NSButton *groupWriteSwitch;
    IBOutlet NSButton *groupExecuteSwitch;
    IBOutlet NSButton *otherReadSwitch;
    IBOutlet NSButton *otherWriteSwitch;
    IBOutlet NSButton *otherExecuteSwitch;
    
    IBOutlet NSMenuItem *deleteMenuItem;
    IBOutlet NSMenuItem *mkdirMenuItem;
    IBOutlet NSMenuItem *permissionMenuItem;
    IBOutlet NSMenuItem *copyURLMenuItem;
    
    IBOutlet Network *network;

    NSMutableArray *hostList;

    NSArray *listName;
    NSArray *listNameLong;
    NSArray *listDir;
    NSString *currentLocalPath;  
    NSString *remoteDirectory;  
    
    NSMutableDictionary *toolbarDict;
    
    BOOL menuEnabled;
    BOOL mlst;
}


- (id) hostListTableColumn: (NSTableColumn *)tableColumn
		row: (int)row;
- (id) fileListTableColumn: (NSTableColumn *)tableColumn
		row: (int)row;

- (IBAction) connect: (NSButton *) Sender;
- (IBAction) addHostToList: (NSButton *) sender;
- (IBAction) hostListClick: (id) sender;
-(void) setButtonState:(NSButton *)button fromDict:(NSDictionary *)dict
        forKey:(NSString *)key defaultValue:(BOOL) defaultValue;
- (IBAction) removeHostListItem: (NSButton *) sender;
- (IBAction) setDefaultHost: (NSButton *) sender;
-(FILE *) newLogFile;
- (void) refresh;
- (void) setHostWindowTitle;
- (void)windowDidResize:(NSNotification *)aNotification;
- (NSArray *) directoryListFromNameLong:(NSArray *)list;
- (IBAction) openDirectory: (id) Sender;
- (IBAction) upDirectory: (id) Sender;
- (IBAction) getFile: (id) Sender;
- (IBAction) fileListDoubleClick: (NSTableView *) Sender;
- (IBAction) disconnect: (NSButton *) Sender;
- (void)windowWillClose:(NSNotification *)aNotification;
- (void) getDirectory: (NSString *) remoteFile to: (NSString *) localFile;
- (IBAction) putFile: (NSButton *) Sender;
- (BOOL) isDirectory: (NSString *) path;
- (void) putDirectory: (NSString *) localFile;
- (IBAction) deleteFile: (NSMenuItem *) sender;
- (void) deleteDirectory: (NSString *) remoteFile;
- (IBAction) makeDirectory: (NSButton *) sender;
- (IBAction) coupleButton: (NSButton *) sender;
- (void) setUpToolbarToWindow:(NSWindow *) window;
-(void) setToolbarItemName:(NSString *)name label:(NSString *)label
            tip:(NSString *)tip image:(NSString *)image
            action:(SEL)action;
-(IBAction) copyURL:(NSMenu *)sender;
-(void) setMenuEnabled:(BOOL)enabled;
-(IBAction) willMakeDirectory:(NSMenuItem *)sender;
-(IBAction) willChangePermission: (NSMenuItem *) sender;
-(void) readPermission;
-(IBAction) setPermission: (NSButton *) sender;
@end
