//
//  DragAndDrop.m
//  YariTori
//
//  Created by Satoshi Takahashi on Sun Sep 15 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

#import "DragAndDrop.h"
#import "Network.h"
#import "AppControler.h"

@implementation DragAndDrop

- (void) awakeFromNib
{
	[self setVerticalMotionCanBeginDrag: YES];
}

- (id)initWithCoder:(NSCoder *)coder
{
    if(self=[super initWithCoder:coder]){
        [self registerForDraggedTypes: [NSArray arrayWithObjects:
					NSFilenamesPboardType, 0]];
    }
    return self;
}


- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{
//NSLog(@"enter");
//NSLog([[[sender draggingPasteboard] types] description]);

	if ([sender draggingSource] == self)
		return NSDragOperationNone;
	if ( [[[sender draggingPasteboard] types] containsObject: NSFilenamesPboardType]
				&& [sender draggingSourceOperationMask] & NSDragOperationCopy )
	{
		highlight=YES;
		[self setNeedsDisplay: YES];
		return NSDragOperationCopy;
	}
    return NSDragOperationNone;
}


- (NSDragOperation)draggingUpdated:(id <NSDraggingInfo>)sender
{
	if (highlight)
		return NSDragOperationCopy;
	else
		return NSDragOperationNone;
}


- (void)draggingExited:(id <NSDraggingInfo>)sender
{
    highlight=NO;
    [self setNeedsDisplay: YES];
}

-(void)drawRect:(NSRect)rect
{
    [super drawRect:rect];
    if(highlight){
        [[NSColor grayColor] set];
        [NSBezierPath setDefaultLineWidth: 5];
        [NSBezierPath strokeRect: rect];
    }
}


- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender
{
    highlight=NO;
    [self setNeedsDisplay: YES];
	if ([sender draggingSource] == self)
		return NO;
    return [[[sender draggingPasteboard] types]
					containsObject: NSFilenamesPboardType];
} 


- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
{
NSEnumerator *enumerator;
NSString *filename;
//NSLog(@"perform");
//NSLog([[sender draggingSource] description]);
//NSLog([self description]);

	if ([sender draggingSource] == self)
		return NO;
	[[sender draggingPasteboard] types];
	enumerator = [(NSArray *)[[sender draggingPasteboard] propertyListForType:
				NSFilenamesPboardType] objectEnumerator];
	while (filename = [enumerator nextObject])
	{
		if ([controler isDirectory: filename])
            [controler putDirectory: filename];
		else
			[network put:filename crlf:[crlfSwitch state]];
	}
    [controler refresh];
    return YES;
}



- (void)draggedImage:(NSImage *)anImage endedAt:(NSPoint)aPoint operation:(NSDragOperation)operation
{
//NSLog(@"dragEnd");
	if (!NSPointInRect(aPoint, [hostWindow frame]))
		[controler getFile: self];
}


@end
