//
//  Network.h
//  FTPGet
//
//  Created by Satoshi Takahashi on Sun Jan 13 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#include <sys/time.h>

#define BUFSIZE 4096

@interface Network : NSObject {
    int socketControl;
    FILE *logFile;
    //struct timeval timeout; /*{sec, microsec}*/
    char reply[BUFSIZE];
    NSString *host;
    NSString *serverCode;
    NSString *user;
    
    BOOL sshTunneling;
    int sshPort;
    BOOL passive;
    BOOL ssh;
    
    FILE *pipeOutput;
    char sshPath[1024];
    char tmpCommand[2048];
    char tmpCommand2[2048];
}

-(void) setLogFile:(FILE *)newLogFile;
-(void) setServerCode:(NSString *)newServerCode;
-(void) setSshTunneling:(BOOL)newSshTunneling;
-(BOOL) sshTunneling;
-(int) makeConnectionToHost:(const char *)cHost  port:(int)port;
-(void) killSshPort:(int)port;
-(int) connectHost:(NSString *)aHost
            port:(int)port
            user:(NSString *)aUser
            password:(NSString *)pass
            path:(NSString *)path
            timeout:(double)timeout
            sshTunnel:(BOOL)doSshTunneling
            passive:(BOOL)doPassive
            ssh:(BOOL)doSSH;
-(int) getReply;
-(int) getReply:(int)fd;
-(void) sendString:(const char *)str;
-(void) sendSocket:(int)fd  string:(const char *)str;
-(void) sendFormat:(const char *)format  string:(const char *)str;
-(void) sendFormat:(const char *)format  string:(const char *)str  logging:(BOOL)logFlag;
-(void) sendSocket:(int)fd  format:(const char *)format  string:(const char *)str;
-(void) sendSocket:(int)fd  format:(const char *)format  string:(const char *)str logging:(BOOL)logFlag;
-(void) getPasvPort:(int *)portP  ofHost:(char *)passiveHost;
-(NSString *) pwd;
-(NSArray *) nameList;
-(NSArray *) nameListHideDot:(BOOL)hideDotFlag;
-(NSArray *) nameListSSHHideDot:(BOOL)hideDotFlag longList:(BOOL)longFlag;
-(NSArray *) directoryList;
-(NSArray *) directoryListHideDot:(BOOL)hideDotFlag;
-(NSArray *) nameListLongHideDot:(BOOL)hideDotFlag;
-(NSArray *) nameListNormalHideDot:(BOOL)hideDotFlag longList:(BOOL)longFlag;
//-(int) setNameList:(NSArray **)listName dirList: (NSArray **)listDir
//            hideDot:(BOOL)hideDotFlag;
-(void) cd:(NSString *)directory;
-(void) cdup;
-(void) get:(NSString *)getName  to:(NSString *)saveName;
-(void) quit;
-(NSString *) stringFromEUC:(const char *)str;
-(NSString *) stringFromShiftJIS:(const char *)str;
-(NSString *) stringFromServerCode:(const char *)str;
-(const char *) EUCFromString:(NSString *)path;
-(const char *)ShiftJISFromString: (NSString *) path;
-(const char *) serverCodeFromString:(NSString *)string;
-(void) put:(NSString *)localFile;
-(void) put:(NSString *)localFile crlf:(BOOL)crlfFlag;
void ConvertCRLF(char *buf, size_t n);
-(void) getSSHDirectory:(NSString *)getName to:(NSString *)saveName;
-(void) putSSHDirectory:(NSString *)localFile;
-(int) mkdir:(NSString *)dirName;
-(void) delete:(NSString *)fileName;
-(void) rmdir:(NSString *)fileName;
-(int) setDataPort: (int *) dataPort;
-(int) openDataPortWithCommand:(char *) command port:(int *) portP;
-(void) sshCommand:(const char *)command;
-(void) sshSystemCommand:(const char *)command;
-(void) writeLog:(const char *)message header:(const char *)header;
-(void) writeLog:(const char *) message header:(const char *)header
        addNL:(BOOL)addNL;
-(void) removeNL:(char *)str;
-(void) setPermission:(int)permInt toFile:(NSString *)file;
-(BOOL) mlstIsDirectory:(NSString *)file mlstResult:(BOOL *)mlstFlagP;
@end


enum {sshTunnelingPort = 8010};
