//
//  Network.m
//  FTPGet
//
//  Created by Satoshi Takahashi on Sun Jan 13 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <stdio.h>
#import <string.h>

#import "Network.h"
#import "sock.h"
#import "pipe.h"


int dataPort = 3202;

@implementation Network

- (void) setLogFile: (FILE *) newLogFile
{
    logFile = newLogFile;
}

- (void) setServerCode: (NSString *) newServerCode
{
    [serverCode autorelease];
    serverCode = [newServerCode copy];
}

-(void) setSshTunneling: (BOOL) newSshTunneling
{
    sshTunneling = newSshTunneling;
}


-(BOOL) sshTunneling
{
    return sshTunneling;
}


-(int) makeConnectionToHost: (const char *) cHost port:(int) port
{
NSString *command;

    if (sshTunneling)
    {
        command = [NSString stringWithFormat:
            @"ssh -N -f -L %d:localhost:%d %s@%s", sshPort, port,
            [user cString], [host cString]];
        NSLog(command);
        fputs([command cString], logFile);
        fputs("\n", logFile);
        fflush(logFile);
        system([command cString]);
        return MakeConnection(sshPort++, "localhost");
    }
    else
        return MakeConnection(port, cHost);
}

#if 0 /*sftp does not work*/
-(int) makeSFTPConnectionToHost: (const char *) cHost port:(int) port
        user: (const char *) cUser
{
char userAtHost[256];

    sprintf(userAtHost, "%s@%s", cUser, cHost);
    //return PipeNewChild("/usr/bin/sftp", "sftp", "-b", "/Users/takahasi/sftp-b.txt", userAtHost, 0);
    return PipeNewChild("/usr/bin/sftp", "sftp", userAtHost, 0);
}
#endif


-(void) killSshPort: (int) port
{
NSString *command;
    if (sshTunneling)
    {
        command = [NSString stringWithFormat:
            @"ps x|grep ssh|grep %d|grep -v grep|cut -c1-5|tr -d \' \'|xargs kill", port];
        system([command cString]);
    }
}

-(int) connectHost:(NSString *)aHost
            port:(int)port
            user:(NSString *)aUser
            password:(NSString *)pass
            path:(NSString *)path
            timeout:(double)timeout
            sshTunnel:(BOOL)doSshTunneling
            passive:(BOOL)doPassive
            ssh:(BOOL)doSSH
{
struct timeval timeoutStruct;
double sec;


NSLog(aHost);
    [host autorelease];
    host = [aHost copy];
    [user autorelease];
    user = [aUser copy];
NSLog(host);
    sshPort = sshTunnelingPort;
    sshTunneling = doSshTunneling;
    passive = doPassive;
    ssh = doSSH;

//NSLog(@"b0");
    timeoutStruct.tv_usec = 1000000*modf(timeout, &sec);
    timeoutStruct.tv_sec = sec;

//NSLog(@"b1");
NSLog(@"%s", [host cString]);
    if (ssh)
    {
        pipeOutput = 0;
        strcpy(sshPath, [self serverCodeFromString: path]);
        return 0;
    }

    socketControl = [self makeConnectionToHost: [host cString]
            port: port];
    if (socketControl < 0)
        return -1;
//NSLog(@"c1");
    fprintf(logFile, "connected to ""%s""\n", [host cString]);
//NSLog(@"b2");

    setsockopt(socketControl, SOL_SOCKET, SO_RCVTIMEO,
            &timeoutStruct, sizeof(timeoutStruct));
    [self getReply];
        if (reply[0] != '2')
        return -1;
//NSLog(@"b3");
    [self sendSocket: socketControl format: "USER %s\r\n" string: [user cString]];
    [self getReply];
    if (reply[0] != '3')
        return -1;
    [self sendFormat: "PASS %s\r\n" string: [pass cString]
            logging: 0];
    [self getReply];
    if (reply[0] != '2')
        return -1;
    [self sendString: "TYPE I"];
    [self getReply];
    if (reply[0] != '2')
        return -1;
//NSLog(@"b4");

    [self cd: path];
    //[self getReply];
        
    return 0;
}


-(int) getReply
{
    return [self getReply: socketControl];
}


-(int) getReply: (int) fd
{
char buf[2][BUFSIZE];
int nread;
int i = 0;
int readFlag = 0;

	if (ssh)
    {
        if (pipeOutput)
        {
            if (fgets(reply, BUFSIZE-1, pipeOutput) != 0)
            {
                fputs(reply, logFile);
                fflush(logFile);
                fputs(reply, stderr);
                fflush(stderr);
                return 1;
            }
            else
                return 0;
        }
        else
            return 0;
    }

    do
    {
        if ((nread = SockGets(fd, buf[i], BUFSIZE-1)) <= 0)
        {
            break;
        }
        readFlag = 1;
        buf[i][nread] = 0;
        fputs(buf[i], logFile);
        fflush(logFile);
        fputs(buf[i], stderr);
        fflush(stderr);
        i = 1 - i;
    } while (!(isdigit(buf[1-i][0]) && isdigit(buf[1-i][1])
                && isdigit(buf[1-i][2]) && isspace(buf[1-i][3])));
    if (readFlag)
        strcpy(reply, buf[1-i]); 
    return readFlag;
}


-(void) sendString: (const char *)str
{
    [self sendSocket: socketControl string: str];
}


-(void) sendSocket: (int) fd string: (const char *)str
{
    if (ssh)
        [self sendSocket: fd format: "%s" string: str logging: YES];
    else
        [self sendSocket: fd format: "%s\r\n" string: str logging: YES];
}


-(void) sendFormat: (const char *) format string: (const char *)str
{
    [self sendSocket: socketControl format: format string: str logging: YES];
}


-(void) sendFormat: (const char *) format string: (const char *)str logging: (BOOL) logFlag
{
    [self sendSocket: socketControl format: format string: str logging: logFlag];
}


-(void) sendSocket: (int) fd format: (const char *) format string: (const char *)str
{
    [self sendSocket: fd format: format string: str logging: YES];
}


-(void) sendSocket: (int) fd format: (const char *) format string: (const char *)str logging: (BOOL)logFlag
{
char message[BUFSIZE];

    sprintf(message, format, str);
    if (logFlag)
    	[self writeLog:message header:"sendSocket: " addNL: NO];
    
    if (ssh)
        pipeOutput = popen(message, "r");
    else
        write(fd, message, strlen(message));
}

-(void) getPasvPort: (int *)portP ofHost: (char *) passiveHost
{
char buf[BUFSIZE];
int nread;
char dummy[128];
int h0, h1, h2, h3, p0, p1;

    [self sendString: "PASV"];
    
    if ((nread = SockGets(socketControl, buf, BUFSIZE)) <= 0)
    {
        *portP = 0;
        return;
    }
    buf[nread] = 0;
    fprintf(logFile, buf);
    fflush(logFile);
    fprintf(stderr, buf);
    fflush(stderr);
    sscanf(buf, "%[^(](%d,%d,%d,%d,%d,%d)", dummy,
                &h0, &h1, &h2, &h3, &p0, &p1);
    //puts(buf);
    //printf("p0=%d, p1=%d\n", p0, p1);
	*portP = p0*256+p1;
    sprintf(passiveHost, "%d.%d.%d.%d", h0, h1, h2, h3);
    return;
}


-(NSString *) pwd
{
int i;

    if (ssh)
    {
        [self sshCommand: "pwd"];
        [self getReply];
        pclose(pipeOutput);
        [self removeNL: reply];
        strcpy(sshPath, reply);
    }
    else
    {
        [self sendString:"PWD"];
        [self getReply];
        sscanf(reply, "%d \"%[^\"]", &i, sshPath);
    }
    return [self stringFromServerCode: sshPath];
}


-(NSArray *) nameList
{
    return [self nameListHideDot:NO];
}

-(NSArray *) nameListHideDot:(BOOL)hideDotFlag 
{
    if (ssh)
        return [self nameListSSHHideDot: hideDotFlag longList: NO];
    else
        return [self nameListNormalHideDot: hideDotFlag longList: NO];
}


-(NSArray *) nameListSSHHideDot:(BOOL)hideDotFlag 
        longList:(BOOL)longFlag
{
char command[32] = "ls";
NSMutableArray *nameList = [[NSMutableArray alloc] init];

    if (!hideDotFlag)
        strcat(command, " -a");
    if (longFlag)
        strcat(command, " -lL");
    
    [self sshCommand: command];
    if (!pipeOutput)
        return 0;

    if (longFlag)
    {
        fgets(reply, BUFSIZE-1, pipeOutput);/*skip first line*/
        fputs(reply, logFile);
    }
    while (fgets(reply, BUFSIZE-1, pipeOutput))
    {
        fputs(reply, logFile);
        [self removeNL: reply];
        [nameList addObject: [self stringFromServerCode: reply]];
    }
    fflush(logFile);
    pclose(pipeOutput);
    return nameList;
}


-(NSArray *) directoryList
{
    return [self directoryListHideDot:NO];
}


-(NSArray *) directoryListHideDot:(BOOL)hideDotFlag
{
NSMutableArray *directoryList = [[NSMutableArray alloc] init];
int port;
int socketData;
char buf[BUFSIZE];
int nread;
int isDirectory;

    if (hideDotFlag)
        socketData = [self openDataPortWithCommand: "LIST" port: &port];
    else
        socketData = [self openDataPortWithCommand: "LIST -a" port: &port];

    while ((nread = SockGets(socketData, buf, BUFSIZE-1)) > 0)
    {
        if (buf[0] != 'd' && buf[0] != '-' && buf[0] != 'l')
            continue;
        isDirectory = ((buf[0] == 'd') || (buf[0] == 'l'));
        [directoryList addObject: [NSNumber numberWithInt: isDirectory]];
    }
    close(socketData);
    [self killSshPort: port];
    
    [self getReply];
    return directoryList;
}

-(NSArray *) nameListLongHideDot:(BOOL)hideDotFlag
{
    if (ssh)
        return [self nameListSSHHideDot: hideDotFlag longList: YES];
    else
        return [self nameListNormalHideDot: hideDotFlag longList: YES];
}


-(NSArray *) nameListNormalHideDot:(BOOL)hideDotFlag longList:(BOOL)longFlag
{
NSMutableArray *nameList = [[NSMutableArray alloc] init];
int port;
int socketData;
char buf[BUFSIZE];
int nread;

    if (!longFlag)
        socketData = [self openDataPortWithCommand: "NLST -a" port: &port];
    else if (hideDotFlag)
        socketData = [self openDataPortWithCommand: "LIST" port: &port];
    else
        socketData = [self openDataPortWithCommand: "LIST -a" port: &port];

    while ((nread = SockGets(socketData, buf, BUFSIZE-1)) > 0)
    {
        fputs(buf, logFile);
        if (longFlag && buf[0] != 'd' && buf[0] != '-' && buf[0] != 'l')
            continue;
        if (hideDotFlag && buf[0] == '.')
                continue;
        if (buf[nread-2] == '\r')
            buf[nread-2] = 0;
        else
            buf[nread-1] = 0;
        [nameList addObject: [self stringFromServerCode: buf]];
    }
    fflush(logFile);
    close(socketData);
    [self killSshPort: port];
    
    [self getReply];
    return nameList;
}


#if 0
-(int) setNameList:(NSArray **)listNameP dirList: (NSArray **)listDirP
            hideDot:(BOOL)hideDotFlag
{
NSMutableArray *nameList = [[NSMutableArray alloc] init];
NSMutableArray *directoryList = [[NSMutableArray alloc] init];
int port;
int socketData;
char buf[BUFSIZE];
int nread;
char *name;
char *dirString;
char *type;
BOOL isDirectory = 0;

    socketData = [self openDataPortWithCommand: "MLSD" port: &port];

    if (reply[0] == '5')
    {
        close(socketData);
        [self killSshPort: port];
        return -1;
    }

    while ((nread = SockGets(socketData, buf, BUFSIZE-1)) > 0)
    {
        if (!(name = strchr(buf, ' ')))
            continue;
        name++;
        if (hideDotFlag && name[0] == '.')
                continue;
        if (buf[nread-2] == '\r')
            buf[nread-2] = 0;
        else
            buf[nread-1] = 0;
        [nameList addObject: [self stringFromServerCode: name]];
        
        if ((dirString = strstr(buf, "Type=")) != 0)
        {
        	strtok(dirString, "=");
            if ((type = strtok(0,";")) != 0)
                isDirectory = strcmp(type, "file");
        }
        [directoryList addObject: [NSNumber numberWithInt: isDirectory]];
    }
    close(socketData);
    [self killSshPort: port];
    [self getReply];

    *listNameP = nameList;
    *listDirP = directoryList;
    return 0;
}
#endif



-(void) cd: (NSString *) directory
{
    if (ssh)
        sprintf(sshPath, "%s/%s", sshPath, 
                [self serverCodeFromString: directory]);
    else
    {
        [self sendFormat: "CWD %s\r\n" string:
                [self serverCodeFromString: directory]];
        [self getReply];
    }
}


-(void) cdup
{
    if (ssh)
        [self cd: @".."];
    else
    {
        [self sendString: "CDUP"];
        [self getReply];
    }
}

-(void) get: (NSString *) getName to: (NSString *) saveName
{
int port;
int socketData;
char buf[BUFSIZE];
int nread;
FILE *saveFile;

    if (ssh)
    {
        sprintf(tmpCommand, "scp -B \'%s@%s:%s/%s\' \'%s\'", [user cString], [host cString],
                sshPath, [self serverCodeFromString: getName],
                [saveName fileSystemRepresentation]);
        [self writeLog: tmpCommand header:"get: "];
        system(tmpCommand);
        return;
    }

    sprintf(tmpCommand, "RETR %s", [self serverCodeFromString: getName]);
    socketData = [self openDataPortWithCommand: tmpCommand port: &port];    

    saveFile = fopen([saveName fileSystemRepresentation], "w");
    if (!saveFile)
        return;
    while ((nread = SockGets(socketData, buf, BUFSIZE-1)) > 0)
    {
        fwrite(buf, 1, nread, saveFile);
    }
    close(socketData);
    [self killSshPort: port];
    fclose(saveFile);
    
    [self getReply];
}


-(void) quit
{
    if (ssh)
        return;

    [self sendString: "QUIT"];
    [self getReply];
    [self killSshPort: 21];
}


-(NSString *) stringFromEUC: (const char *)str
{
    return [[[NSString alloc] initWithData:[NSData dataWithBytes: str
                length: strlen(str)] encoding: NSJapaneseEUCStringEncoding]
                autorelease];
}


-(NSString *) stringFromShiftJIS: (const char *)str
{
    return [[[NSString alloc] initWithData:[NSData dataWithBytes: str
                length: strlen(str)] encoding: NSShiftJISStringEncoding]
                autorelease];
}


-(NSString *) stringFromServerCode: (const char *)str
{
    if ([serverCode isEqualToString: @"EUC"])
        return [self stringFromEUC: str];
    else if ([serverCode isEqualToString: @"UTF8"])
        return [NSString stringWithUTF8String: str];
    else if ([serverCode isEqualToString: @"Shift JIS"])
        return [self stringFromShiftJIS: str];
    else
        return [self stringFromEUC: str];
}


-(const char *)EUCFromString: (NSString *) path
{
NSData *pathData;
static char buf[BUFSIZE];

    pathData = [path dataUsingEncoding: NSJapaneseEUCStringEncoding
                    allowLossyConversion: YES];
    strncpy(buf, (char *)[pathData bytes], [pathData length]);
    buf[[pathData length]] = 0;
    return buf;
}


-(const char *)ShiftJISFromString: (NSString *) path
{
NSData *pathData;
static char buf[BUFSIZE];

    pathData = [path dataUsingEncoding: NSShiftJISStringEncoding
                    allowLossyConversion: YES];
    strncpy(buf, (char *)[pathData bytes], [pathData length]);
    buf[[pathData length]] = 0;
    return buf;
}


-(const char *) serverCodeFromString: (NSString *) string
{
    if ([serverCode isEqualToString: @"EUC"])
        return [self EUCFromString: string];
    else if ([serverCode isEqualToString: @"UTF8"])
        return [string UTF8String];
    else if ([serverCode isEqualToString: @"Shift JIS"])
        return [self ShiftJISFromString: string];
    else
        return [self EUCFromString: string];
}


-(void) put: (NSString *) localFile
{
    [self put:localFile crlf:NO];
}


-(void) put:(NSString *)localFile crlf:(BOOL)crlfFlag
{
int port;
int socketData;
char buf[BUFSIZE];
size_t nread;
FILE *readFile;

    if (ssh)
    {
        sprintf(tmpCommand, "scp -B \'%s\' \'%s@%s:%s\'/",
                [self serverCodeFromString: localFile],
                [user cString], [host cString], sshPath);
        [self writeLog: tmpCommand header:"put: "];
        system(tmpCommand);
        return;
    }

    sprintf(tmpCommand, "STOR %s", [self serverCodeFromString:
            [localFile lastPathComponent]]);
    [self getReply];
    socketData = [self openDataPortWithCommand: tmpCommand port: &port];    

    readFile = fopen([localFile fileSystemRepresentation], "r");
    if (!readFile)
        return;
    while ((nread =  fread(buf, 1, BUFSIZE, readFile)) > 0)
    {
        if (crlfFlag)
           ConvertCRLF(buf, nread);
    	write(socketData, buf, nread);
    }
    close(socketData);
    [self killSshPort: port];
    fclose(readFile);
    [self getReply];
    
}

void ConvertCRLF(char *buf, size_t n)
{
size_t i;
    for(i = 0; i < n && i < BUFSIZE; i++)
    {
        if (buf[i] == '\r')
            buf[i] = '\n';
    }
}


-(void) getSSHDirectory:(NSString *)getName to:(NSString *)saveName
{
    sprintf(tmpCommand, "scp -Br \'%s@%s:%s/%s\' \'%s\'", [user cString], [host cString],
            sshPath, [self serverCodeFromString: getName],
            [saveName fileSystemRepresentation]);
    [self writeLog: tmpCommand header:"getDirecroty: "];
    system(tmpCommand);
    return;
}

-(void) putSSHDirectory:(NSString *)localFile 
{
    sprintf(tmpCommand, "scp -Br \'%s\' \'%s@%s:%s/\'",
            [self serverCodeFromString: localFile],
            [user cString], [host cString], sshPath);
    [self writeLog: tmpCommand header:"putDirecroty: "];
    system(tmpCommand);
    return;
}


-(int) mkdir: (NSString *) dirName
{
    if (ssh)
    {
        sprintf(tmpCommand, "mkdir %s", [self serverCodeFromString: dirName]);
        [self sshSystemCommand: tmpCommand];
        return 0;
    }
    else
    {
        [self sendFormat: "MKD %s\r\n" string: [self serverCodeFromString: dirName]];
        [self getReply];
        return - (reply[0] != '2');
    }
}


- (void) delete:(NSString *)fileName
{
    if (ssh)
    {
        sprintf(tmpCommand, "rm %s", [self serverCodeFromString: fileName]);
        [self sshSystemCommand: tmpCommand];
    }
    else
    {
        [self sendFormat: "DELE %s\r\n" string: [self serverCodeFromString: fileName]];
        [self getReply];
    }
}


- (void) rmdir: (NSString *) fileName
{
    if (ssh)
    {
        sprintf(tmpCommand, "rm -r %s", [self serverCodeFromString: fileName]);
        [self sshSystemCommand: tmpCommand];
    }
    else
    {
        [self sendFormat: "RMD %s\r\n" string: [self serverCodeFromString: fileName]];
        [self getReply];
    }
}


/* active */
- (int) setDataPort:(int *) dataPort
{
char portCom[256];
int hostIP[4];

    (*dataPort)++;


    GetLocalIP(hostIP);
    sprintf(portCom, "PORT %d,%d,%d,%d,%d,%d",
                hostIP[0], hostIP[1], hostIP[2], hostIP[3],
                *dataPort/256, *dataPort%256);

    [self sendSocket: socketControl string: portCom];

    return StartListening(*dataPort);
}


- (int) openDataPortWithCommand:(char *) command port:(int *) portP
{
int socketData;
int port;
char dataHost[20];

    if (passive)
    {
        [self getPasvPort: &port ofHost: dataHost];
        socketData = [self makeConnectionToHost: dataHost port: port];
        if (!socketData)
            return 0;
    }
    else
    {
        socketData = [self setDataPort: &dataPort];
        [self getReply];
    }
    [self sendString: command];
    [self getReply];
    if (reply[0] == '5')
        return socketData;
    if (!passive)
    {
        socketData = MakeAcception(socketData);
    }
    *portP = port;
    return socketData;
}


-(void) sshCommand:(const char *)command
{
    sprintf(tmpCommand2, "ssh \'%s@%s\' \"(cd \'%s\'; \"%s\")\"", [user cString],
            [host cString], sshPath, command);

    [self writeLog: tmpCommand2 header:"sshCommand: "];

    pipeOutput = popen(tmpCommand2, "r");
    return;
}

-(void) sshSystemCommand:(const char *)command
{
    sprintf(tmpCommand2, "ssh \'%s@%s\' \"(cd \'%s\'; \"%s\")\"", [user cString],
            [host cString], sshPath, command);
    [self writeLog: tmpCommand2 header:"sshCommand: "];
    system(tmpCommand2);
    return;
}

-(void) writeLog:(const char *) message header:(const char *)header
{
    [self writeLog:message header:header addNL:YES];
}


-(void) writeLog:(const char *) message header:(const char *)header
        addNL:(BOOL)addNL
{
    fprintf(logFile, "%s%s%c", header, message,addNL?'\n':'\0');
    fflush(logFile);
    fprintf(stderr, "%s%s%c", header, message,addNL?'\n':'\0');
    fflush(stderr);
}

-(void) removeNL:(char *)str
{
int i;
    i = strlen(str);
    if (str[i-1] == '\n')
        str[i-1] = 0;
}


-(void) setPermission:(int)permInt toFile: (NSString *)file
{
    if (ssh)
    {
        sprintf(tmpCommand, "chmod %03d \'%s\'", permInt,
                [self serverCodeFromString: file]);
        [self sshCommand: tmpCommand];
    }
    else
    {
        sprintf(tmpCommand, "SITE CHMOD %03d %s", permInt,
                [self serverCodeFromString: file]);
        [self sendString: tmpCommand];
        [self getReply];
    }
}


-(BOOL) mlstIsDirectory:(NSString *)file mlstResult:(BOOL *)mlstFlagP
{
int nread;
char *dirString;
char *type;
BOOL result=NO;
    

    [self sendFormat: "MLST %s\r\n" string:
            [self serverCodeFromString: file]];

    if ((nread = SockGets(socketControl, reply, BUFSIZE-1)) <= 0)
        return NO;
    [self writeLog: reply header: "" addNL: NO];
    if (reply[0] == '5')
        return NO;
    
    SockGets(socketControl, reply, BUFSIZE-1);
    [self writeLog: reply header: "" addNL: NO];
    if ((dirString = strstr(reply, "Type=")) != 0)
    {
        strtok(dirString, "=");
        if ((type = strtok(0,";")) != 0)
        {
            result = strcmp(type, "file");
        }
    }
    
    [self getReply];    
    
    return result;
}
@end