/*
 *  sock.c
 *  FTPSync
 *
 *  Created by takahasi on Mon Dec 31 2001.
 *  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
 *
 */
//#include <Foundation/Foundation.h>
#include <sys/types.h>

#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <stdio.h>
#include <string.h>

#include "sock.h"

#if 0
static int atoport(char *service, char *proto)
{
  int port;
  struct servent *serv;

  /* First try to read it from /etc/services */
  serv = getservbyname(service, proto);
  if (serv != NULL)
    port = serv->s_port;
  else { 
      return -1; /* Invalid port address */
  }
  return port;
}
#endif


/* Converts ascii text to in_addr struct.  NULL is returned if the address
   can not be found. */
static struct in_addr *atoaddr(const char *address)
{
  struct hostent *host;
  static struct in_addr saddr;

  /* First try it as aaa.bbb.ccc.ddd. */
  saddr.s_addr = inet_addr(address);
  if (saddr.s_addr != -1) {
    return &saddr;
  }
  host = gethostbyname(address);
  if (host != NULL) {
    return (struct in_addr *) *host->h_addr_list;
  }
  return NULL;
}


//int MakeConnection(char *service, int type, char *netaddress)
int MakeConnection(int port, const char *netaddress)
{
struct in_addr *addr;
int sock, connected;
struct sockaddr_in address;
    
    addr = atoaddr(netaddress);
    if (addr == NULL) {
        perror("make_connection:  Invalid network address.\n");
        return -1;
    }
    
    memset((char *) &address, 0, sizeof(address));
    address.sin_family = AF_INET;
    address.sin_port = (port);
    address.sin_addr.s_addr = addr->s_addr;
    
    sock = socket(AF_INET, SOCK_STREAM, 0);

    connected = connect(sock, (struct sockaddr *) &address, 
        sizeof(address));
    if (connected < 0) {
        perror("connect");
        return -1;
    }
    return sock;
}


int SockGets(int sockfd, char *str, size_t count)
{
    int bytes_read;
    int total_count = 0;
    char *current_position;
    char last_read = 0;
    const char kLinefeed = 10;
    //const char kCR = 13;
    
    current_position = str;
    while (last_read != kLinefeed) {
        bytes_read = read(sockfd, &last_read, 1);
//putchar(last_read);
        if (bytes_read <= 0) {
        /* The other side may have closed unexpectedly */
            return -1; /* Is this effective on other platforms than linux? */
        }
        if ( (total_count < count) /*&& (last_read != kLinefeed) /*&& 
        (last_read !=kCR)*/ )
         {
            current_position[0] = last_read;
            current_position++;
            total_count++;
        }
    }
    if (count > 0)
        current_position[0] = 0;
    return total_count;
}


//int MakeConnection(char *service, int type, char *netaddress)
int StartListening(int port)
{
struct in_addr *addr;
int sock;
struct sockaddr_in address;
char hostname[64];
int result;

    gethostname(hostname, sizeof(hostname));
    
    addr = atoaddr(hostname);
    if (addr == NULL) {
        perror("make_connection:  Invalid network address.\n");
        return -1;
    }
    
    memset((char *) &address, 0, sizeof(address));
    address.sin_family = AF_INET;
    address.sin_port = (port);
    address.sin_addr.s_addr = addr->s_addr;
    
    sock = socket(AF_INET, SOCK_STREAM, 0);

    result = bind(sock, (struct sockaddr *) &address, 
        sizeof(address));
    if (result < 0) {
        perror("bind");
        return -1;
    }
    
    result = listen(sock, 5);
    if (result < 0) {
        perror("listen");
        return -1;
    }
    
    return sock;
}

int MakeAcception(int sock)
{
struct in_addr address;
int adrLen;
int accepted;

    accepted = accept(sock, (struct sockaddr *) &address, 
        &adrLen);
    if (accepted < 0) {
        perror("accept");
        return -1;
    }
    return accepted;
}


void GetLocalIP(int hostIP[4])
{
struct in_addr *addr;
char hostname[64];

    gethostname(hostname, sizeof(hostname));
    
    addr = atoaddr(hostname);
    if (addr == NULL) {
        perror("make_connection:  Invalid network address.\n");
        return;
    }
    
    hostIP[0] = (addr->s_addr)/256U/256U/256U;
    hostIP[1] = ((addr->s_addr)/256U/256U)%256U;
    hostIP[2] = ((addr->s_addr)/256U)%256U;
    hostIP[3] = (addr->s_addr)%256U;
}
